"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ItemTitle = exports.ItemSubtitle = exports.ItemPrimitive = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactNative = require("react-native");

var _children = require("../children");

var _displayNames = require("../display-names");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const ItemPrimitive = _ref => {
  let {
    children,
    style
  } = _ref;
  const titleChildren = (0, _children.pickChildren)(children, ItemTitle);

  let title = /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null);

  if (typeof children == 'string') {
    // not encouraged usage. might remove later. don't document
    // ItemTitle should be used directly instead.
    title = /*#__PURE__*/_react.default.createElement(ItemTitle, null, children);
  } else {
    var _titleChildren$target, _titleChildren$target2;

    title = (_titleChildren$target = (_titleChildren$target2 = titleChildren.targetChildren) === null || _titleChildren$target2 === void 0 ? void 0 : _titleChildren$target2[0]) !== null && _titleChildren$target !== void 0 ? _titleChildren$target : /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null);
  }

  return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: style
  }, title, titleChildren.withoutTargetChildren.filter(child => typeof child != 'string'));
};

exports.ItemPrimitive = ItemPrimitive;
const ItemTitle = (0, _displayNames.create)(_ref2 => {
  let {
    children,
    style
  } = _ref2;
  return /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: style,
    selectable: false
  }, children);
}, 'ItemTitle');
exports.ItemTitle = ItemTitle;
const ItemSubtitle = (0, _displayNames.create)(_ref3 => {
  let {
    children,
    style
  } = _ref3;
  return /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: style,
    selectable: false
  }, children);
}, 'ItemSubtitle');
exports.ItemSubtitle = ItemSubtitle;
//# sourceMappingURL=index.js.map