import React from 'react';
import { Text, View } from 'react-native';
import { pickChildren } from '../children';
import { create } from '../display-names';

const ItemPrimitive = _ref => {
  let {
    children,
    style
  } = _ref;
  const titleChildren = pickChildren(children, ItemTitle);
  let title = /*#__PURE__*/React.createElement(React.Fragment, null);

  if (typeof children == 'string') {
    // not encouraged usage. might remove later. don't document
    // ItemTitle should be used directly instead.
    title = /*#__PURE__*/React.createElement(ItemTitle, null, children);
  } else {
    var _titleChildren$target, _titleChildren$target2;

    title = (_titleChildren$target = (_titleChildren$target2 = titleChildren.targetChildren) === null || _titleChildren$target2 === void 0 ? void 0 : _titleChildren$target2[0]) !== null && _titleChildren$target !== void 0 ? _titleChildren$target : /*#__PURE__*/React.createElement(React.Fragment, null);
  }

  return /*#__PURE__*/React.createElement(View, {
    style: style
  }, title, titleChildren.withoutTargetChildren.filter(child => typeof child != 'string'));
};

const ItemTitle = create(_ref2 => {
  let {
    children,
    style
  } = _ref2;
  return /*#__PURE__*/React.createElement(Text, {
    style: style,
    selectable: false
  }, children);
}, 'ItemTitle');
const ItemSubtitle = create(_ref3 => {
  let {
    children,
    style
  } = _ref3;
  return /*#__PURE__*/React.createElement(Text, {
    style: style,
    selectable: false
  }, children);
}, 'ItemSubtitle');
export { ItemPrimitive, ItemSubtitle, ItemTitle };
//# sourceMappingURL=index.js.map