import React from 'react';
import { ContextMenuContentProps, MenuGroupProps, MenuItemProps, MenuRootProps, MenuSeparatorProps, MenuTriggerProps, MenuItemIndicatorProps, MenuSubProps } from '../menu';
declare const Root: React.FC<MenuRootProps>;
declare const Trigger: React.FC<MenuTriggerProps>;
declare const Content: React.FC<ContextMenuContentProps>;
declare const Item: React.FC<{
    children: React.ReactNode;
    style?: import("react-native").StyleProp<import("react-native").ViewStyle>;
    textValue?: string | undefined;
} & {
    onSelect?: (() => void) | undefined;
    disabled?: boolean | undefined;
    hidden?: boolean | undefined;
    destructive?: boolean | undefined;
    onFocus?: (() => void) | undefined;
    onBlur?: (() => void) | undefined;
    key: string;
}>;
declare const SubTrigger: React.FC<Omit<MenuItemProps, "onSelect"> & {
    key: string;
}>;
declare const Group: React.FC<MenuGroupProps>;
declare const Separator: React.FC<MenuSeparatorProps>;
declare const CheckboxItem: React.FC<Omit<MenuItemProps, "onSelect"> & {
    value: boolean | "mixed" | "on" | "off";
    onValueChange?: ((state: "mixed" | "on" | "off", prevState: "mixed" | "on" | "off") => void) | undefined;
    key: string;
}>;
declare const ItemIndicator: React.FC<MenuItemIndicatorProps>;
declare const ItemIcon: React.FC<import("../menu").MenuItemCommonProps & {
    children?: React.ReactNode;
    style?: import("react-native").StyleProp<import("react-native").ViewStyle>;
}>;
declare const Preview: React.FC<unknown>;
declare const Arrow: React.FC<{
    height?: number | undefined;
    width?: number | undefined;
    children?: React.ReactNode;
    asChild?: boolean | undefined;
} & Pick<React.SVGAttributes<SVGSVGElement>, "style" | "className" | "fill">>;
declare const Sub: React.FC<MenuSubProps>;
declare const SubContent: React.FC<ContextMenuContentProps & Pick<import("../menu").MenuContentProps, "sideOffset">>;
declare const Auxiliary: React.FC<Omit<import("react-native-ios-context-menu").MenuAuxiliaryPreviewConfig, "marginAuxiliaryPreview"> & {
    children: React.ReactNode | ((options: {
        dismissMenu: () => void;
    }) => React.ReactNode);
    onDidShow?: (() => void) | undefined;
    marginWithScreenEdge?: number | undefined;
    onWillShow?: (() => void) | undefined;
}>;
export { Root, Trigger, Content, Item, SubTrigger, Group, Separator, CheckboxItem, ItemIndicator, ItemIcon, Preview, Arrow, Sub, SubContent, Auxiliary, };
export { ItemImage } from '../menu/web-primitives/item-image';
export { Label } from './web/label';
export { ItemTitle, ItemSubtitle } from '../menu';
