import React from 'react';
import { MenuContentProps, MenuGroupProps, MenuItemProps, MenuRootProps, MenuSeparatorProps, MenuSubTriggerProps, MenuTriggerProps, MenuCheckboxItemProps, MenuItemIndicatorProps, MenuItemIconProps, MenuSubProps, MenuSubContentProps } from '../menu';
declare const Root: {
    ({ children, onOpenChange }: MenuRootProps): JSX.Element;
    displayName: "Root";
};
declare const Trigger: {
    ({ children, style, asChild }: MenuTriggerProps): JSX.Element;
    displayName: "Trigger";
};
declare const Content: {
    ({ children, style, loop, side, align, alignOffset, avoidCollisions, collisionPadding, sideOffset, }: MenuContentProps): JSX.Element;
    displayName: "Content";
};
declare const Item: {
    ({ children, disabled, onSelect, style, onBlur, onFocus, textValue, }: MenuItemProps): JSX.Element;
    displayName: "Item";
};
declare const SubTrigger: {
    ({ children, style, textValue, disabled, onBlur, onFocus, }: MenuSubTriggerProps): JSX.Element;
    displayName: "SubTrigger";
};
declare const Group: {
    ({ children }: MenuGroupProps): JSX.Element;
    displayName: "Group";
};
declare const Separator: {
    ({ style }: MenuSeparatorProps): JSX.Element;
    displayName: "Separator";
};
declare const CheckboxItem: {
    ({ onValueChange, value, disabled, textValue, onBlur, onFocus, style, children, }: MenuCheckboxItemProps): JSX.Element;
    displayName: "CheckboxItem";
};
declare const ItemIndicator: {
    ({ style, children }: MenuItemIndicatorProps): JSX.Element;
    displayName: "ItemIndicator";
};
declare const ItemIcon: {
    ({ children, style }: MenuItemIconProps): JSX.Element;
    displayName: "ItemIcon";
};
declare const Arrow: React.FC<{
    height?: number | undefined;
    width?: number | undefined;
    children?: React.ReactNode;
    asChild?: boolean | undefined;
} & Pick<React.SVGAttributes<SVGSVGElement>, "style" | "className" | "fill">>;
declare const Sub: React.FC<MenuSubProps>;
declare const SubContent: React.FC<MenuSubContentProps>;
export { Root, Trigger, Content, Item, SubTrigger, Group, Separator, CheckboxItem, ItemIndicator, ItemIcon, Arrow, Sub, SubContent, };
export { ItemImage } from '../menu/web-primitives/item-image';
export { Label } from './web/label';
export { ItemTitle, ItemSubtitle } from '../menu';
