/**
 * Credit to geist-ui/react for this file, it's copied from there.
 */
import React, { ReactNode, ReactChild, ReactElement } from 'react';
type ReactChildArray = ReturnType<typeof React.Children.toArray>;
export declare function flattenChildrenKeyless(children: React.ReactNode): ReactChildArray;
export declare function flattenChildren(children: ReactNode, depth?: number, keys?: (string | number)[]): ReactChild[];
export declare const pickChildren: <Props = any>(_children: React.ReactNode | undefined, targetChild: React.ElementType) => {
    targetChildren: React.ReactElement<Props, string | React.JSXElementConstructor<any>>[] | undefined;
    withoutTargetChildren: React.ReactChild[];
};
export declare const isInstanceOfComponent: <Props>(element: React.ReactElement | React.ReactText | undefined, targetElement: React.ComponentClass<Props, any> | React.FunctionComponent<Props> | (Props extends React.SVGProps<SVGSymbolElement> ? "symbol" : never) | (Props extends React.DetailedHTMLProps<React.ObjectHTMLAttributes<HTMLObjectElement>, HTMLObjectElement> ? "object" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "small" : never) | (Props extends React.DetailedHTMLProps<React.StyleHTMLAttributes<HTMLStyleElement>, HTMLStyleElement> ? "style" : never) | (Props extends React.DetailedHTMLProps<React.AnchorHTMLAttributes<HTMLAnchorElement>, HTMLAnchorElement> ? "a" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "abbr" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "address" : never) | (Props extends React.DetailedHTMLProps<React.AreaHTMLAttributes<HTMLAreaElement>, HTMLAreaElement> ? "area" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "article" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "aside" : never) | (Props extends React.DetailedHTMLProps<React.AudioHTMLAttributes<HTMLAudioElement>, HTMLAudioElement> ? "audio" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "b" : never) | (Props extends React.DetailedHTMLProps<React.BaseHTMLAttributes<HTMLBaseElement>, HTMLBaseElement> ? "base" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "bdi" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "bdo" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "big" : never) | (Props extends React.DetailedHTMLProps<React.BlockquoteHTMLAttributes<HTMLElement>, HTMLElement> ? "blockquote" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLBodyElement>, HTMLBodyElement> ? "body" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLBRElement>, HTMLBRElement> ? "br" : never) | (Props extends React.DetailedHTMLProps<React.ButtonHTMLAttributes<HTMLButtonElement>, HTMLButtonElement> ? "button" : never) | (Props extends React.DetailedHTMLProps<React.CanvasHTMLAttributes<HTMLCanvasElement>, HTMLCanvasElement> ? "canvas" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "caption" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "cite" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "code" : never) | (Props extends React.DetailedHTMLProps<React.ColHTMLAttributes<HTMLTableColElement>, HTMLTableColElement> ? "col" : never) | (Props extends React.DetailedHTMLProps<React.ColgroupHTMLAttributes<HTMLTableColElement>, HTMLTableColElement> ? "colgroup" : never) | (Props extends React.DetailedHTMLProps<React.DataHTMLAttributes<HTMLDataElement>, HTMLDataElement> ? "data" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLDataListElement>, HTMLDataListElement> ? "datalist" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "dd" : never) | (Props extends React.DetailedHTMLProps<React.DelHTMLAttributes<HTMLElement>, HTMLElement> ? "del" : never) | (Props extends React.DetailedHTMLProps<React.DetailsHTMLAttributes<HTMLElement>, HTMLElement> ? "details" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "dfn" : never) | (Props extends React.DetailedHTMLProps<React.DialogHTMLAttributes<HTMLDialogElement>, HTMLDialogElement> ? "dialog" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLDivElement>, HTMLDivElement> ? "div" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLDListElement>, HTMLDListElement> ? "dl" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "dt" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "em" : never) | (Props extends React.DetailedHTMLProps<React.EmbedHTMLAttributes<HTMLEmbedElement>, HTMLEmbedElement> ? "embed" : never) | (Props extends React.DetailedHTMLProps<React.FieldsetHTMLAttributes<HTMLFieldSetElement>, HTMLFieldSetElement> ? "fieldset" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "figcaption" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "figure" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "footer" : never) | (Props extends React.DetailedHTMLProps<React.FormHTMLAttributes<HTMLFormElement>, HTMLFormElement> ? "form" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLHeadingElement>, HTMLHeadingElement> ? "h1" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLHeadingElement>, HTMLHeadingElement> ? "h2" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLHeadingElement>, HTMLHeadingElement> ? "h3" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLHeadingElement>, HTMLHeadingElement> ? "h4" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLHeadingElement>, HTMLHeadingElement> ? "h5" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLHeadingElement>, HTMLHeadingElement> ? "h6" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLHeadElement>, HTMLHeadElement> ? "head" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "header" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "hgroup" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLHRElement>, HTMLHRElement> ? "hr" : never) | (Props extends React.DetailedHTMLProps<React.HtmlHTMLAttributes<HTMLHtmlElement>, HTMLHtmlElement> ? "html" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "i" : never) | (Props extends React.DetailedHTMLProps<React.IframeHTMLAttributes<HTMLIFrameElement>, HTMLIFrameElement> ? "iframe" : never) | (Props extends React.DetailedHTMLProps<React.ImgHTMLAttributes<HTMLImageElement>, HTMLImageElement> ? "img" : never) | (Props extends React.DetailedHTMLProps<React.InputHTMLAttributes<HTMLInputElement>, HTMLInputElement> ? "input" : never) | (Props extends React.DetailedHTMLProps<React.InsHTMLAttributes<HTMLModElement>, HTMLModElement> ? "ins" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "kbd" : never) | (Props extends React.DetailedHTMLProps<React.KeygenHTMLAttributes<HTMLElement>, HTMLElement> ? "keygen" : never) | (Props extends React.DetailedHTMLProps<React.LabelHTMLAttributes<HTMLLabelElement>, HTMLLabelElement> ? "label" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLLegendElement>, HTMLLegendElement> ? "legend" : never) | (Props extends React.DetailedHTMLProps<React.LiHTMLAttributes<HTMLLIElement>, HTMLLIElement> ? "li" : never) | (Props extends React.DetailedHTMLProps<React.LinkHTMLAttributes<HTMLLinkElement>, HTMLLinkElement> ? "link" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "main" : never) | (Props extends React.DetailedHTMLProps<React.MapHTMLAttributes<HTMLMapElement>, HTMLMapElement> ? "map" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "mark" : never) | (Props extends React.DetailedHTMLProps<React.MenuHTMLAttributes<HTMLElement>, HTMLElement> ? "menu" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "menuitem" : never) | (Props extends React.DetailedHTMLProps<React.MetaHTMLAttributes<HTMLMetaElement>, HTMLMetaElement> ? "meta" : never) | (Props extends React.DetailedHTMLProps<React.MeterHTMLAttributes<HTMLElement>, HTMLElement> ? "meter" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "nav" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "noindex" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "noscript" : never) | (Props extends React.DetailedHTMLProps<React.OlHTMLAttributes<HTMLOListElement>, HTMLOListElement> ? "ol" : never) | (Props extends React.DetailedHTMLProps<React.OptgroupHTMLAttributes<HTMLOptGroupElement>, HTMLOptGroupElement> ? "optgroup" : never) | (Props extends React.DetailedHTMLProps<React.OptionHTMLAttributes<HTMLOptionElement>, HTMLOptionElement> ? "option" : never) | (Props extends React.DetailedHTMLProps<React.OutputHTMLAttributes<HTMLElement>, HTMLElement> ? "output" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLParagraphElement>, HTMLParagraphElement> ? "p" : never) | (Props extends React.DetailedHTMLProps<React.ParamHTMLAttributes<HTMLParamElement>, HTMLParamElement> ? "param" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "picture" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLPreElement>, HTMLPreElement> ? "pre" : never) | (Props extends React.DetailedHTMLProps<React.ProgressHTMLAttributes<HTMLProgressElement>, HTMLProgressElement> ? "progress" : never) | (Props extends React.DetailedHTMLProps<React.QuoteHTMLAttributes<HTMLQuoteElement>, HTMLQuoteElement> ? "q" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "rp" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "rt" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "ruby" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "s" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "samp" : never) | (Props extends React.DetailedHTMLProps<React.SlotHTMLAttributes<HTMLSlotElement>, HTMLSlotElement> ? "slot" : never) | (Props extends React.DetailedHTMLProps<React.ScriptHTMLAttributes<HTMLScriptElement>, HTMLScriptElement> ? "script" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "section" : never) | (Props extends React.DetailedHTMLProps<React.SelectHTMLAttributes<HTMLSelectElement>, HTMLSelectElement> ? "select" : never) | (Props extends React.DetailedHTMLProps<React.SourceHTMLAttributes<HTMLSourceElement>, HTMLSourceElement> ? "source" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLSpanElement>, HTMLSpanElement> ? "span" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "strong" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "sub" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "summary" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "sup" : never) | (Props extends React.DetailedHTMLProps<React.TableHTMLAttributes<HTMLTableElement>, HTMLTableElement> ? "table" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLTemplateElement>, HTMLTemplateElement> ? "template" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLTableSectionElement>, HTMLTableSectionElement> ? "tbody" : never) | (Props extends React.DetailedHTMLProps<React.TdHTMLAttributes<HTMLTableDataCellElement>, HTMLTableDataCellElement> ? "td" : never) | (Props extends React.DetailedHTMLProps<React.TextareaHTMLAttributes<HTMLTextAreaElement>, HTMLTextAreaElement> ? "textarea" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLTableSectionElement>, HTMLTableSectionElement> ? "tfoot" : never) | (Props extends React.DetailedHTMLProps<React.ThHTMLAttributes<HTMLTableHeaderCellElement>, HTMLTableHeaderCellElement> ? "th" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLTableSectionElement>, HTMLTableSectionElement> ? "thead" : never) | (Props extends React.DetailedHTMLProps<React.TimeHTMLAttributes<HTMLElement>, HTMLElement> ? "time" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLTitleElement>, HTMLTitleElement> ? "title" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLTableRowElement>, HTMLTableRowElement> ? "tr" : never) | (Props extends React.DetailedHTMLProps<React.TrackHTMLAttributes<HTMLTrackElement>, HTMLTrackElement> ? "track" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "u" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLUListElement>, HTMLUListElement> ? "ul" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "var" : never) | (Props extends React.DetailedHTMLProps<React.VideoHTMLAttributes<HTMLVideoElement>, HTMLVideoElement> ? "video" : never) | (Props extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement> ? "wbr" : never) | (Props extends React.DetailedHTMLProps<React.WebViewHTMLAttributes<HTMLWebViewElement>, HTMLWebViewElement> ? "webview" : never) | (Props extends React.SVGProps<SVGSVGElement> ? "svg" : never) | (Props extends React.SVGProps<SVGElement> ? "animate" : never) | (Props extends React.SVGProps<SVGElement> ? "animateMotion" : never) | (Props extends React.SVGProps<SVGElement> ? "animateTransform" : never) | (Props extends React.SVGProps<SVGCircleElement> ? "circle" : never) | (Props extends React.SVGProps<SVGClipPathElement> ? "clipPath" : never) | (Props extends React.SVGProps<SVGDefsElement> ? "defs" : never) | (Props extends React.SVGProps<SVGDescElement> ? "desc" : never) | (Props extends React.SVGProps<SVGEllipseElement> ? "ellipse" : never) | (Props extends React.SVGProps<SVGFEBlendElement> ? "feBlend" : never) | (Props extends React.SVGProps<SVGFEColorMatrixElement> ? "feColorMatrix" : never) | (Props extends React.SVGProps<SVGFEComponentTransferElement> ? "feComponentTransfer" : never) | (Props extends React.SVGProps<SVGFECompositeElement> ? "feComposite" : never) | (Props extends React.SVGProps<SVGFEConvolveMatrixElement> ? "feConvolveMatrix" : never) | (Props extends React.SVGProps<SVGFEDiffuseLightingElement> ? "feDiffuseLighting" : never) | (Props extends React.SVGProps<SVGFEDisplacementMapElement> ? "feDisplacementMap" : never) | (Props extends React.SVGProps<SVGFEDistantLightElement> ? "feDistantLight" : never) | (Props extends React.SVGProps<SVGFEDropShadowElement> ? "feDropShadow" : never) | (Props extends React.SVGProps<SVGFEFloodElement> ? "feFlood" : never) | (Props extends React.SVGProps<SVGFEFuncAElement> ? "feFuncA" : never) | (Props extends React.SVGProps<SVGFEFuncBElement> ? "feFuncB" : never) | (Props extends React.SVGProps<SVGFEFuncGElement> ? "feFuncG" : never) | (Props extends React.SVGProps<SVGFEFuncRElement> ? "feFuncR" : never) | (Props extends React.SVGProps<SVGFEGaussianBlurElement> ? "feGaussianBlur" : never) | (Props extends React.SVGProps<SVGFEImageElement> ? "feImage" : never) | (Props extends React.SVGProps<SVGFEMergeElement> ? "feMerge" : never) | (Props extends React.SVGProps<SVGFEMergeNodeElement> ? "feMergeNode" : never) | (Props extends React.SVGProps<SVGFEMorphologyElement> ? "feMorphology" : never) | (Props extends React.SVGProps<SVGFEOffsetElement> ? "feOffset" : never) | (Props extends React.SVGProps<SVGFEPointLightElement> ? "fePointLight" : never) | (Props extends React.SVGProps<SVGFESpecularLightingElement> ? "feSpecularLighting" : never) | (Props extends React.SVGProps<SVGFESpotLightElement> ? "feSpotLight" : never) | (Props extends React.SVGProps<SVGFETileElement> ? "feTile" : never) | (Props extends React.SVGProps<SVGFETurbulenceElement> ? "feTurbulence" : never) | (Props extends React.SVGProps<SVGFilterElement> ? "filter" : never) | (Props extends React.SVGProps<SVGForeignObjectElement> ? "foreignObject" : never) | (Props extends React.SVGProps<SVGGElement> ? "g" : never) | (Props extends React.SVGProps<SVGImageElement> ? "image" : never) | (Props extends React.SVGProps<SVGLineElement> ? "line" : never) | (Props extends React.SVGProps<SVGLinearGradientElement> ? "linearGradient" : never) | (Props extends React.SVGProps<SVGMarkerElement> ? "marker" : never) | (Props extends React.SVGProps<SVGMaskElement> ? "mask" : never) | (Props extends React.SVGProps<SVGMetadataElement> ? "metadata" : never) | (Props extends React.SVGProps<SVGElement> ? "mpath" : never) | (Props extends React.SVGProps<SVGPathElement> ? "path" : never) | (Props extends React.SVGProps<SVGPatternElement> ? "pattern" : never) | (Props extends React.SVGProps<SVGPolygonElement> ? "polygon" : never) | (Props extends React.SVGProps<SVGPolylineElement> ? "polyline" : never) | (Props extends React.SVGProps<SVGRadialGradientElement> ? "radialGradient" : never) | (Props extends React.SVGProps<SVGRectElement> ? "rect" : never) | (Props extends React.SVGProps<SVGStopElement> ? "stop" : never) | (Props extends React.SVGProps<SVGSwitchElement> ? "switch" : never) | (Props extends React.SVGProps<SVGTextElement> ? "text" : never) | (Props extends React.SVGProps<SVGTextPathElement> ? "textPath" : never) | (Props extends React.SVGProps<SVGTSpanElement> ? "tspan" : never) | (Props extends React.SVGProps<SVGUseElement> ? "use" : never) | (Props extends React.SVGProps<SVGViewElement> ? "view" : never)) => element is React.ReactElement<Props, string | React.JSXElementConstructor<any>>;
export {};
